-- Model: CA - BLINK: ALIVE OR DEAD
--
-- Author: Tiago Carneiro
--
-- Lesson: How cellular space synchronization works?  

--------------------------------------------------------------
-- PARAMETERS
--------------------------------------------------------------
ALIVE = true
DEAD  = false

--------------------------------------------------------------
-- MODEL (1. space, 2. behavior, and 3. time)
--------------------------------------------------------------

-------------
--# SPACE #
-------------
cs = CellularSpace{
	xdim = 10
}


print("Create attributes")
forEachCell( cs, function(c)
	c.isAlive = ALIVE
end)

print("Create the past")
-- (1) COMMENT THE LINE BELOW AND EXPLAIN WHAT HAPPEND
cs:synchronize()

print("Traverse celluar spaces")
forEachCell( cs, function(c)
	--print(c.x, c.y, c.isAlive)
end)

cs:createNeighborhood{
	strategy = "moore",
	self = false
}


----------------
--# BEHAVIOR #
----------------

function rules() 
	forEachCell( cs, function(c)
		local counter = 0
		local aliveNeighbors = 0
		forEachNeighbor( c, function(cell, neigh)
			counter = counter + 1
			-- (2) WHAT ".past" DOES MEAN IN THE LINE BELOW?
			-- TO UNDERSTAND ITS EFFECT IN MODEL'S BEHAVIOR,  
			-- RUN THE MODEL WITH AND WHITOUT ".past" AND COMPARE THE OUTCOMES
			if( neigh.past.isAlive == ALIVE ) then
				aliveNeighbors = aliveNeighbors + 1	
			end
		end )
		
		if( counter == aliveNeighbors) then
			c.isAlive = DEAD
		else
			c.isAlive = ALIVE
		end
		print(c.x, c.y, c.isAlive, counter)
	end)
end

-----------
--# TIME #
-----------

--------------------------------------------------------------
-- SIMULATION
--------------------------------------------------------------
for t = 1, 2 do

	print(t, "----------")
	rules()
	
	cs:synchronize() -- (3) COMMENT THIS LINE AND EXPLAIN WHAT HAPPEND
end